﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace DragAndDrop
{
    public partial class Form1 : Form
    {

        private string s;
        private FarPoint.Win.Spread.Model.CellRange cr;
        public Form1()
        {

            InitializeComponent();
        }
       

        private void Form1_Load(object sender, EventArgs e)
        {            
                       
            listBox1.AllowDrop = true;
            fpSpread2.AllowDrop = true;
            fpSpread2.AllowDragDrop = true;

            cr = new FarPoint.Win.Spread.Model.CellRange(0, 0, 1, 1);
            s = fpSpread1.ActiveSheet.GetClip(0, 0, 1, 1);

            string pathname;
            pathname = Environment.GetFolderPath(Environment.SpecialFolder.ProgramFiles) + "\\GrapeCity\\Spread Studio 8\\Common\\";
            string conStr = "Provider=Microsoft.JET.OLEDB.4.0;data source= " + pathname + "Patients2000.mdb";
            string sqlStr = "SELECT * FROM Patients";
            System.Data.OleDb.OleDbConnection conn = new System.Data.OleDb.OleDbConnection(conStr);
            DataSet ds = new DataSet();
            System.Data.OleDb.OleDbDataAdapter da = new System.Data.OleDb.OleDbDataAdapter(sqlStr, conn);
            fpSpread1.ActiveSheet.DataAutoSizeColumns = true;
            da.Fill(ds);
            fpSpread1.DataSource = ds;
        }

        private void fpSpread2_DragDrop(object sender, DragEventArgs e)
        {
            int r, c, rc, cc;
            r = cr.Row;
            c = cr.Column;
            rc = cr.RowCount;
            cc = cr.ColumnCount;
            FarPoint.Win.Spread.Model.CellRange sel = fpSpread2.ActiveSheet.GetSelection(0);
            if (sel != null)
                fpSpread2.ActiveSheet.SetClip(sel.Row, sel.Column, sel.RowCount, sel.ColumnCount, s);
            
        }

        private void fpSpread2_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.Text))
            {
                e.Effect = DragDropEffects.Move;
            }
            
        }

        private void fpSpread2_DragOver(object sender, DragEventArgs e)
        {
            int r, c, rc, cc;
            r = cr.Row;
            c = cr.Column;
            rc = cr.RowCount;
            cc = cr.ColumnCount;
            Point p = fpSpread2.PointToClient(new Point(e.X, e.Y));
            FarPoint.Win.Spread.Model.CellRange range = fpSpread2.GetCellFromPixel(0, 0, p.X, p.Y);
            if (range.ColumnCount == -1 && range.RowCount == -1)
                return;
            FarPoint.Win.Spread.Model.CellRange sel = fpSpread2.ActiveSheet.GetSelection(0);
            if (sel != null)
            fpSpread2.ActiveSheet.RemoveSelection(sel.Row, sel.Column, sel.RowCount, sel.ColumnCount);


            if (cc == -1)
            {
                fpSpread2.ActiveSheet.AddSelection(range.Row, -1, rc, -1);
            }
            else if (rc == -1)
            {
                fpSpread2.ActiveSheet.AddSelection(-1, range.Column, -1, cc);
            }
            else
            {
                fpSpread2.ActiveSheet.AddSelection(range.Row, range.Column, rc, cc);
            }
            
           
        }

        private void fpSpread1_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Right)
            {
                fpSpread1.DoDragDrop(s, DragDropEffects.Copy | DragDropEffects.Move);
            }
            
        }

        private void fpSpread1_MouseUp(object sender, MouseEventArgs e)
        {
            try
            {
                cr = fpSpread1.ActiveSheet.GetSelection(0);
                s = fpSpread1.ActiveSheet.GetClip(cr.Row, cr.Column, cr.RowCount, cr.ColumnCount);
            }
            catch (Exception ex)
            {

                MessageBox.Show(ex.ToString() + "You did not make a selection!");
                return;
            }
           
        }

        private void listBox1_DragDrop(object sender, DragEventArgs e)
        {
            string listitem;
            listitem = fpSpread1.Sheets[0].GetText(fpSpread1.Sheets[0].ActiveRowIndex, fpSpread1.Sheets[0].ActiveColumnIndex);
            listBox1.Items.Add(listitem);
        }

       

        private void listBox1_DragOver(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.Text))
            {
                e.Effect = DragDropEffects.Move;
            }
        }
    }
}
